function rnacounts = generatescseqdata(kon,koff,lambda,tau,ncells,tpoint,dwell,saveinterval)

if nargin<8 || isempty(saveinterval)
    saveinterval = NaN;
end
if nargin<7 || isempty(dwell)
    dwell = 120;
end
if nargin<6 || isempty(tpoint)
    tpoint = 4500; % make sure this is much longer than any timescale in the system
end

[kon,koff,lambda,tau] = matchsize(kon,koff,lambda,tau);

rnacounts = zeros(numel(kon),ncells);

wb = timerBar('Running',numel(kon));

if ~isnan(saveinterval)
    savname = sprintf('tempsav%s.mat',char(64 + ceil(26*rand(1,4))));
end

for ii = 1:numel(kon)
    R = [1-kon(ii),kon(ii);koff(ii),1-koff(ii)];
    rnacounts(ii,:) = multirnasim(R,[0,lambda(ii)],tau(ii),dwell,tpoint,tpoint,ncells);
    wb.increment();
    if ~isnan(saveinterval) && mod(ii,saveinterval)==0
        save(savname,'rnacounts','ii');
    end
end

wb.finish();
