function data = groupstats(xy,gg,maxg)

% attempt to generalize the group averaging functions

% gg should be the same size and shape as one column of xy
% if array grouping is required, write a wrapper function to do the
% flattening and arranging into columns

if nargin<3 || isempty(maxg)
    maxg = max(gg(:));
end

% get the array groupings
gg = gg(:)*ones(1,size(xy,2));
dimg = ones(size(xy,1),1)*(1:size(xy,2));

flatdata = xy(:);
flatg = [gg(:),dimg(:)];

% to begin with, just want mean, stdev and number.  May as well also
% calculate the stderr here, since it'll be used a lot..

datasiz = [maxg,size(xy,2)];

data.sum = accumarray(flatg,flatdata,datasiz);
data.nn = accumarray(flatg,ones(size(flatdata)),datasiz);
data.sum2 = accumarray(flatg,flatdata.^2,datasiz);

data.mean = data.sum./data.nn;
data.stdev = sqrt((data.nn./(data.nn-1)).*(data.sum2./data.nn - data.mean.^2));

data.stderr = data.stdev./sqrt(data.nn);